
using System;

namespace Dizzy
{


	public class Log
	{
		
		public delegate void LogEvent (string message);
		public static event LogEvent StatusBarUpdate;
		
		/* Debug mode */
		public static bool debugMode = false;
		
		public Log ()
		{
		}
		
		public static void Error (string message)
		{
			// Facciamo capire che è un errore
			ConsoleColor initial = Console.ForegroundColor;
			Console.ForegroundColor = ConsoleColor.DarkRed;
			Console.Write (" ==> ");
			Console.WriteLine (message);
			Console.ForegroundColor = initial;
		}
		
		
		public static void Warning (string message)
		{
			// Facciamo capire che è un errore
			ConsoleColor initial = Console.ForegroundColor;
			Console.ForegroundColor = ConsoleColor.Cyan;
			Console.Write (" ==> ");
			Console.WriteLine (message);
			Console.ForegroundColor = initial;
		}
		
		
		public static void Info (string message)
		{
			// Facciamo capire che è un errore
			ConsoleColor initial = Console.ForegroundColor;
			Console.ForegroundColor = ConsoleColor.Green;
			Console.Write (" ==> ");
			Console.WriteLine (message);
			Console.ForegroundColor = initial;
			try {StatusBarUpdate(message);}
			catch (Exception e) { Log.Error ("Impossibile loggare sulla statusbar" + e.Message); }
		}
		
		public static void Lock (string message)
		{
			ConsoleColor initial = Console.ForegroundColor;
			Console.Write (" ==> ");
			Console.ForegroundColor = ConsoleColor.DarkGray;
			Console.WriteLine (message);
			Console.ForegroundColor = initial;
		}
		
		public static void Debug(string domain, string message) {
			if (!debugMode)
				return;
			ConsoleColor initial = Console.ForegroundColor;
			Console.Write (" ==> ");
			Console.ForegroundColor = ConsoleColor.Magenta;
			Console.WriteLine (message);
			Console.ForegroundColor = initial;
		}
	}
}
